From: "Sicelo A. Mhlongo" <absicsz@gmail.com>
Date: Wed, 4 Dec 2024 12:07:34 +0200
Subject: stkutil: ensure data fits in buffer

Fixes CVE-2024-7545

(cherry picked from commit 556e14548c38c2b96d85881542046ee7ed750bb5)

Origin: upstream, https://git.kernel.org/pub/scm/network/ofono/ofono.git/commit/?id=556e14548c38c2b96d85881542046ee7ed750bb5
Bug-Debian: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1078555
---
 src/stkutil.c | 4 ++++
 1 file changed, 4 insertions(+)

diff --git a/src/stkutil.c b/src/stkutil.c
index 2bcb509..88a715d 100644
--- a/src/stkutil.c
+++ b/src/stkutil.c
@@ -1942,6 +1942,10 @@ static bool parse_dataobj_mms_content_id(
 
 	data = comprehension_tlv_iter_get_data(iter);
 	mci->len = len;
+
+	if (len > sizeof(mci->id))
+		return false;
+
 	memcpy(mci->id, data, len);
 
 	return true;
